<?xml version="1.0"?>

<st-source>
<!-- Changes in change set PV -->
<time-stamp>From VisualWorks®, 7.4.1 of May 30, 2006 on September 7, 2007 at 10:52:07 am</time-stamp>


<class>
<name>UBACache</name>
<environment>PROVISO.UBA</environment>
<super>PROVISO.PvSmeeObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>state </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>NGUBA-Support</category>
<attributes>
<package>NGUBA-Support</package>
</attributes>
</class>

<class>
<name>PvModelResyncAgent</name>
<environment>PROVISO</environment>
<super>PROVISO.PvObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>pvModel removedObjects updatedProperties resyncActions testResyncActions bufferActions lastStartSeconds lastEndSeconds server onPostResync </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Managers</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.UBA.UBAOperator</class-id> <category>api-events</category>

<body package="NGUBA-Application" selector="smeeOnResync:">smeeOnResync: aNiladicFunction
	&lt;prototypeFunctionNamed: #onResync comment: 'Call function when resnyc has happened'&gt;

	"the block wrapper is used here so that we keep the operator as the 'this' in the callback"
	self modelImporter onResync: [aNiladicFunction valueWithThis: self]</body>
</methods>


<methods>
<class-id>PROVISO.PvFormula class</class-id> <category>instance creation</category>

<body package="PV-DM-Support" selector="onSmeePrototype:sourceText:">onSmeePrototype: aFormulaPrototype sourceText: text

	| path |
	path := aFormulaPrototype name findToken: $~.
	^self new
		name: path last;
		type: self smeeLanguageCode;
		flags: 0;
		comment: 'Created by ECMAScript formula install tool';
		sourceText: text;
		persistent: 1;
		formulaPrototype: aFormulaPrototype;
		genericId: aFormulaPrototype genericId;
		date: self timeFacade now asUTCSeconds;
		origin: 'APinstall';
		username: 'APdev';
		dataType: 'float';
		expressionType: 'fixed';
		state: 'on';
		curve: 0;
		yourself</body>
</methods>


<methods>
<class-id>PROVISO.UBA.ModelGenerator</class-id> <category>events</category>

<body package="NGUBA-Application" selector="onResync:">onResync: aNiladicBlock 
	
	self pvModel resyncAgent onPostResync: aNiladicBlock</body>
</methods>


<methods>
<class-id>PROVISO.CmeESTreeBuilder</class-id> <category>building aggregate buckets</category>

<body package="PV-CME-Core" selector="buildRaBucketsForTimeSeries:contextResource:">buildRaBucketsForTimeSeries: ts contextResource: aSubelement
	| raBucket buildBlock |
	
	self shouldBuildRaAndGaBuckets
		ifFalse: [^self].

	(ts shouldStore and: [ts notNil and: [ts formula isString not and: [ts formula isProperty not and: [ts formula isPeriodicTimeSeries and: [ts isLocalStreamLabel]]]]]) 
		ifFalse: [^self].
	" If this is an indirectly built bucket, use the top-level request for its reporting groups "
	buildBlock := 
		[:eachGroup | 
		eachGroup hasTimezoneAndCalendar 
			ifTrue: 
				[raBucket := 
					self 
						buildRaBucketForGroup: eachGroup
						timeSeries: ts]].
	" If this is an indirectly built bucket, use the top-level request for its reporting groups "
	aSubelement parentsDo: buildBlock.
	ts resource inverseRelationsDo: 
		[:eachRel | eachRel composite ifNotNil: [:obj | obj parentsDo: buildBlock]]</body>
</methods>


<methods>
<class-id>PROVISO.MetricSeriesIdentifier</class-id> <category>accessing</category>

<body package="PV-Streams-Support" selector="genericId">genericId

	^self formula notNil
		ifTrue: [self formula genericId]
		ifFalse: [nil]</body>
</methods>


<reorganize>
<class-id>PROVISO.MetricSeriesIdentifier</class-id> <organization>('comparing' #= #hash)
('serialization' #writeOn:)
('printing' #printOn:)
('accessing' #formula #formula: #genericId #metric #msid #msid: #resource #resource:)
('byte-accessing' #metricId #resourceId)
</organization>
</reorganize>

<methods>
<class-id>PROVISO.UBA.ModelImporter</class-id> <category>private</category>

<body package="NGUBA-Application" selector="onResync:">onResync: aNiladicBlock 
	
	self pvModel resyncAgent onPostResync: aNiladicBlock</body>
</methods>


<methods>
<class-id>PROVISO.UBA.UBACache class</class-id> <category>creation</category>

<body package="NGUBA-Support" selector="smeeNewWithPrototype:with:">smeeNewWithPrototype: prototype with: aNumber
	&lt;constructByEitherWithArgs: #(prototype nil)&gt;
	| newObject |
Transcript cr;show: 'Yes size'.	
	newObject := self basicNewObjectWithPrototype: prototype.
	aNumber isNil ifTrue: [] ifFalse: [newObject initializeWith: aNumber smeeToNumber].
	^newObject</body>
</methods>

<methods>
<class-id>PROVISO.UBA.UBACache</class-id> <category>private</category>

<body package="NGUBA-Support" selector="initialize">initialize

	super initialize.
	state := PvLargeDictionary new: 1024.</body>

<body package="NGUBA-Support" selector="initializeWith:">initializeWith: aSize

	super initialize.
	state := PvLargeDictionary new: aSize.</body>
</methods>

<methods>
<class-id>PROVISO.UBA.UBACache</class-id> <category>public</category>

<body package="NGUBA-Support" selector="smeeGetValue:">smeeGetValue: key
	&lt;instanceFunctionNamed: 'get' length: 1 args: 'key&lt;String&gt;' comment: 'Get a value from the cache'&gt;
	^state at: key smeeToPrimitiveString ifAbsent: [nil]</body>

<body package="NGUBA-Support" selector="smeePutValue:value:">smeePutValue: key value: value
	&lt;instanceFunctionNamed: 'put' length: 2 args: 'key&lt;String&gt; value' comment: 'Put a value in the cache'&gt;
	^state at: key smeeToPrimitiveString put: value</body>
</methods>


<methods>
<class-id>PROVISO.FormulaSet</class-id> <category>accessing</category>

<body package="PV-ES-Formulas" selector="defineFormula:">defineFormula: aSmeeObject
	&lt;prototypeFunctionNamed: #defineFormula length: 1 args: #(nil) comment: 'Define a formula and add it to the collection'&gt;

	| name answer formula |
	name := aSmeeObject smeeAt: #name ifAbsent: [^self error: 'missing formula name'].
	name size &gt; 0 ifFalse: [^self error: 'missing formula name'].
	(name at: 1) = $~ ifTrue: [name := name copyFrom: 2 to: name size].
	formula := Formula new
					name: name;
					formulaSet: self;
					arguments: 
						(Array streamContents: 
							[ :s |
							((aSmeeObject smeeAt: #arguments ifAbsent: [#()]) smeeEnumerablePropertiesDo:
								[ :assoc | | path |
								path := assoc value.
								(path notNil and: [path size &gt; 0 and: [path first = $~]])
									ifTrue: [path := path allButFirst]. 
								s nextPut: 
									(Argument 
										named: assoc key 
										path: assoc value)])]);
					smeeAt: #window put: (aSmeeObject smeeAt: #window ifAbsent: [ nil ]);
					smeeAt: #calculate put: (aSmeeObject smeeAt: #calculate ifAbsent: [[:foo| nil ]]);
					smeeAt: #calculateIntermediate put: (aSmeeObject smeeAt: #calculateIntermediate ifAbsent: [[:foo| nil ]]);
					smeeAt: #reset put: (aSmeeObject smeeAt: #reset ifAbsent: [[:foo| nil ]]);
					yourself.
	(aSmeeObject at: #genericId ifAbsent: [nil]) ifNotNil: [:value | formula genericId: value smeeToPrimitive]. 
	(aSmeeObject at: #deduplicate ifAbsent: [nil]) ifNotNil: [:value | formula deduplicate: value smeeToPrimitive].
	(aSmeeObject at: #deduplicateIntermediate ifAbsent: [nil]) ifNotNil: [:value | formula deduplicateIntermediate: value smeeToPrimitive].
	answer := 
		PvFormula 
			onSmeePrototype: formula
			sourceText: self documentName.
	self formulas 
		at: name
		put: answer.
	^answer</body>
</methods>


<methods>
<class-id>PROVISO.SlePlanBasedBuilder</class-id> <category>private</category>

<body package="PV-CME-Core" selector="applyContextResources">applyContextResources
	
	| time |
	self shouldBuildRaAndGaBuckets: true.
	self system logDebugTwo: #CME_PLAN_STEP text: 'Building RA buckets from context resource records (', self contextResources size printString, 'records)'. 
	time := Time millisecondsToRun: [
	self contextResources do: 
		[:eachAssoc | 
		self 
			buildRaBucketsForTimeSeries: eachAssoc key
			contextResource: eachAssoc value]].

"Walk the entire tree and build ras"
	self rawData do: 
		[:ts | 
		self 
			buildRaBucketsForTimeSeries: ts
			contextResource: ts resource].

	self system logDebugTwo: #CME_PLAN_STAT text: 'Applied ' , self contextResources size printString, ' context resource records in ', (time // 1000) printString, ' seconds'.</body>

<body package="PV-CME-Core" selector="buildResourceBuckets">buildResourceBuckets
	" Since we are building the tree ebfore we have resources, we cannot build RA/GA buckets
	until after we completed loading all the resources. Therefore we disable building RA/GA buckets initially "
	
	| metadataTime1 buildTime1 metadataTime2 buildTime2 |
	self shouldBuildRaAndGaBuckets: false.
	self resyncAgent resync: 
		[self resyncAgent markCurrentObjects.		" This is how we will know which resources are new "
		metadataTime1 := 
			Time millisecondsToRun: [self resyncGlobalMetadata].
		buildTime1 := Time millisecondsToRun: 
			[self buildExternalTimeSeries.
			self buildTimeSeriesAndInputs.
			self processTimeSeriesDeletes.
			self loadContextResources].
		metadataTime2 := Time millisecondsToRun: 
			[" Populate resource id temp table which will drive resynching of all resource-related data "
			self populateTempTable.
			" Now resync all the interesting resource details "
			self resyncAgent 
				resyncFromResourcesDomainManagers: 
						#(elementManager subelementManager propertyManager thresholdManager relationManager)
					between: self metadataStartSeconds
					and: self metadataEndSeconds;
				lastStartSeconds: self metadataStartSeconds;
				lastEndSeconds: self metadataEndSeconds]].
	buildTime2 := Time millisecondsToRun: [self applyContextResources].
	self stats
		timingFor: #preHourlyLoadMetadataSeconds
		is: (metadataTime1 + metadataTime2) // 1000.
	self stats
		timingFor: #preHourlyTreeBuildSeconds
		is: (buildTime1 + buildTime2) // 1000.</body>
</methods>


<methods>
<class-id>PROVISO.UBA.AbstractSchema</class-id> <category>testing</category>

<body package="PVAdaptor-Schema" selector="hasAnySchemaNamed:">hasAnySchemaNamed: aSchemaName

	^self name = aSchemaName</body>
</methods>


<methods>
<class-id>PROVISO.PvSubsystemServer</class-id> <category>tuple storage callbacks</category>

<body package="PV-Application Support" selector="newTupleStreamFor:subscription:">newTupleStreamFor: aTupleContainer subscription: subscription

	| timeStamp dir prefix |
	timeStamp := PvTimestamp fromUTCSeconds: aTupleContainer timestamp.
	dir := (self fileInterface tempTuplePushDirectory, ('Node.', subscription sourceNodeName asString)) tempSubdirectory.
	prefix := timeStamp asProvisoString, '-00000'.
	^MultiMetricRecordWriteStream new
		addDescriptorsForRecordTypes: #('NRAW' 'SNRW' 'SRAW' 'RCMP')
		directory: dir
		prefix: prefix;
		addDescriptor: (PvDataFile fromFilename: (dir, (prefix, '.', 'NRAW', '.BOF'))) at: PvMetricRecord0406;
		yourself</body>
</methods>


<methods>
<class-id>PROVISO.PvCmeStats</class-id> <category>initialization</category>

<body package="PV-CME-Core" selector="initialize">initialize

	self timingBreakdown: (
		Dictionary new
			at: #startOfHour put: 0;
			at: #endOfHour put: 0;
				at: #beginWaitSeconds put: 0;
				at: #preHourlySeconds put: 0;
					at: #preHourlyLoadMetadataSeconds put: 0;
					at: #preHourlyTreeBuildSeconds put: 0;
				at: #hourlySeconds put: 0;
					at: #hourlyFlowControlSeconds put: 0;
					at: #hourlyWaitForDataSeconds put: 0;
					at: #hourlyProcessingFilesMilliseconds put: 0;
					at: #hourlyTrapMilliseconds put: 0;
				at: #postHourlySeconds put: 0;
					at: #postHourlyFlushSeconds put: 0;
					at: #postHourlyCleanupSeconds put: 0;
					at: #postHourlyFlowControlSeconds put: 0;
			yourself).
	self
		metricRecordsIn: 0;
		metricRecordsOut: 0;
		raRecordsOut: 0;
		gaRecordsOut: 0;
		trapEvents: 0;
		badRecordsByMetricId: Dictionary new;
		totalBadRecords: 0;
		metricFilesProcessed: 0;
		stringMetricFilesProcessed: 0;
		closeHourFilesProcessed: 0;
		duplicateRecordCount: 0;
		droppedRecordCount: 0;
		reInventoryRequests: 0;
		reInventoryFailures: 0</body>
</methods>

<methods>
<class-id>PROVISO.PvCmeStats</class-id> <category>accessing</category>

<body package="PV-CME-Core" selector="adjustedStatistics">adjustedStatistics
		
	^self metricRecordsOutPerMinuteOfWork</body>

<body package="PV-CME-Core" selector="hourlyWaitForDataSeconds">hourlyWaitForDataSeconds
	"If we are not flow controlled or working then we must be waiting on data"
		
	^self totalSeconds - self totalFlowControlSeconds - self totalSecondsOfWork</body>

<body package="PV-CME-Core" selector="metricRecordsOutPerMinuteOfWork">metricRecordsOutPerMinuteOfWork
		
	^(self metricRecordsOut / self totalSecondsOfWork * 60) truncated</body>

<body package="PV-CME-Core" selector="totalFlowControlSeconds">totalFlowControlSeconds

	^(self timingFor: #preHourlyFlowControlSeconds) + (self  timingFor: #hourlyFlowControlSeconds) + (self timingFor: #postHourlyFlowControlSeconds).</body>
</methods>

<methods>
<class-id>PROVISO.PvCmeStats</class-id> <category>timing</category>

<body package="PV-CME-Core" selector="totalSeconds">totalSeconds

	^((self timingFor: #endOfHour) - (self timingFor: #startOfHour)) max: 1</body>

<body package="PV-CME-Core" selector="totalSecondsOfWork">totalSecondsOfWork

	^ ((self timingFor: #preHourlySeconds) + ((self timingFor: #hourlyProcessingFilesMilliseconds)  // 1000) + (self timingFor: #postHourlySeconds) - self totalFlowControlSeconds) max: 1</body>
</methods>


<methods>
<class-id>PROVISO.PvRelation class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="resyncSelectFromSubelementResyncTable">resyncSelectFromSubelementResyncTable
	"This statement retrieves relations using gtt_se_resync table to drive the query from the list of subelement ids"

	| namedReplacements |
	namedReplacements := 
		('COLUMNLIST' -&gt; (self allHistoricalColumnsForSelectWithPrefix: 'c.')) asDictionary.
	^'Select /*+ ORDERED NO_MERGE PUSH_SUBQ USE_NL(gtt c) */
       %COLUMNLIST
  From ( Select Idx_Resource
           From GTT_SE_RESYNC
          Where Str_Type = ''S'' ) gtt,
       CO_DESC_HIST c
 Where gtt.Idx_Resource = c.Idx_Member
   And c.Dte_Date = ( Select /*+ INDEX(c1 PK_CODH) */
                             Max(c1.Dte_Date)
                        From CO_DESC_HIST c1
                       Where c1.Idx_Co = c.Idx_Co
                         And c1.Idx_Member = c.Idx_Member
                         And c1.Idx_Relation = c.Idx_Relation
                         And c1.Dte_Date &lt;= :2 )
   And c.Dte_Date Between :1 And :2
   And c.Str_Action In (''I'',''U'',''D'')
' namedBindWithArguments: namedReplacements.</body>

<body package="PV-DM-Support" selector="startupSelectFromSubelementResyncTable">startupSelectFromSubelementResyncTable
	"This statement retrieves properties using gtt_se_resync table to drive the query from the list of subelement ids"
	
	| namedReplacements |
	namedReplacements := 
		('COLUMNLIST' -&gt; (self allHistoricalColumnsForSelectWithPrefix: 'c.')) asDictionary.
	^'Select /*+ ORDERED NO_MERGE PUSH_SUBQ USE_NL(gtt c) */
       %COLUMNLIST
  From ( Select Idx_Resource
           From GTT_SE_RESYNC
          Where Str_Type = ''S'' ) gtt,
       CO_DESC_HIST c
 Where gtt.Idx_Resource = c.Idx_Member
   And c.Dte_Date = ( Select /*+ INDEX(c1 PK_CODH) */
                             Max(c1.Dte_Date)
                        From CO_DESC_HIST c1
                       Where c1.Idx_Co = c.Idx_Co
                         And c1.Idx_Member = c.Idx_Member
                         And c1.Idx_Relation = c.Idx_Relation
                         And c1.Dte_Date &lt;= :2 )
   And c.Dte_Date &lt;= :2
   And c.Str_Action In (''I'',''U'')
' namedBindWithArguments: namedReplacements.</body>
</methods>


<methods>
<class-id>PROVISO.UBA.EncodingBofStream</class-id> <category>streaming</category>

<body package="PVAdaptor Core" selector="nextPutFloatMetric:date:">nextPutFloatMetric: aMetric date: dateString 
	| mr rid formula |
	rid := self resourceIdForMetric: aMetric.
	rid isNil ifTrue:
		[self incrementMissingRIDCount.
		^self].
	formula := self pvModel formulaManager itemNamed: aMetric name ifAbsent: 
		[self recordMissingFormulaName: aMetric name.
		^self].
 
	mr := PvMetricRecord0403 new.
	mr
		dateAndPollId: aMetric date;
		metricId: formula id;
		resourceId: rid;
		value: aMetric value.
	self nextPutRecord: mr.
	self incrementRecordCount.</body>
</methods>


<methods>
<class-id>PROVISO.FormulaOperator</class-id> <category>accessing</category>

<body package="PV-ES-Formulas" selector="genericId">genericId
	^ self id ifNotNil: [:idx | idx genericId]</body>
</methods>


<methods>
<class-id>PROVISO.FormulaOperator</class-id> <category>smee interface</category>

<body package="PV-ES-Formulas" selector="newTupleOfClass:">newTupleOfClass: aClass 
	
	| recManager rec |
	recManager := self metricRecordManager.
	rec := 
		recManager isNil 
			ifTrue: [aClass new]
			ifFalse: [recManager nextRecordOfClass: aClass].
	rec
		metricId: self genericId;
		resourceId: self resourceId.
	^rec</body>
</methods>


<remove-selector>
<class-id>PROVISO.UBA.UBAInterface class</class-id> <selector>smeeNewWithPrototype:named:inputs:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.UBA.UBAInterface</class-id> <category>query</category>

<body package="NGUBA-Application" selector="hasAnySchemaNamed:">hasAnySchemaNamed: aSchemaName

	^self inputs anySatisfy: [:eachInput | eachInput hasAnySchemaNamed: aSchemaName]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.BaseTemporalJoin class</class-id> <category>api-new</category>

<body package="NGUBA-Application" selector="smeeNewWithPrototype:named:inputs:">smeeNewWithPrototype: prototype named: aStringName inputs: anArray
	&lt;constructByEitherWithArgs: #(prototype name inputs) comment: 'Instantiate a new operator and assign inputs.'&gt;
	
	^(self smeeNewWithPrototype: prototype)
		name: aStringName smeeToString;
		initializeForInputs: anArray
		yourself</body>
</methods>


<methods>
<class-id>PROVISO.UBA.BaseTemporalJoin</class-id> <category>accessing</category>

<body package="NGUBA-Application" selector="addHandler:for:">addHandler: anObject for: aSchemaName
	" we don't want to overlay handler once it is set. Maybe change this later -bbuxton 08/08/07 "

	self handlers
		at: aSchemaName
		ifAbsentPut: [anObject]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.BaseTemporalJoin</class-id> <category>processing</category>

<body package="NGUBA-Application" selector="handleNormalTuple:">handleNormalTuple: aTuple 

	self pvNamespace currentTimestamp: aTuple timestamp.
	(self handlerForTuple: aTuple)
		valueWithThis: self
		with: aTuple</body>
</methods>

<methods>
<class-id>PROVISO.UBA.BaseTemporalJoin</class-id> <category>smee api</category>

<body package="NGUBA-Application" selector="smeeAddHandlerFor:function:">smeeAddHandlerFor: aSchemaName function: aClosure
	&lt;prototypeFunctionNamed: #addHandler length: 2 args: 'name&lt;String&gt; handler&lt;Function&gt;' comment: 'Add a handler function for input schema with specified name'&gt;

	(self hasAnySchemaNamed: aSchemaName smeeToString)
		ifFalse: [PvException generic raiseErrorString: 'Input Schema ', aSchemaName smeeToString, ' does not exist'].
	self addHandler: aClosure for: aSchemaName</body>
</methods>


<methods>
<class-id>Smee.SmeeArray</class-id> <category>testing</category>

<body package="Smee-Objects" selector="size">size
	&lt;getterNamed: #size comment: 'Get the size '&gt;

	^collection size</body>
</methods>


<methods>
<class-id>PROVISO.PvModelResyncAgent</class-id> <category>events</category>

<body package="PV-DM-Managers" selector="onPostResync:">onPostResync: aNiladicBlock

	onPostResync := aNiladicBlock</body>
</methods>


<methods>
<class-id>PROVISO.PvModelResyncAgent</class-id> <category>actions</category>

<body package="PV-DM-Managers" selector="postResync">postResync
	
	self resyncActions: OrderedCollection new.
	self pvModel allDomainManagerSelectors do: 
		[:eachSelector | 
		(self pvModel perform: eachSelector) ifNotNil: 
			[:eachManager | eachManager postResync]].
	self fullTreeBuildFlag 
		ifTrue: [self pvModel relink]
		ifFalse: [self pvModel incrementalRelink].
	onPostResync ifNotNil: [:niladic | niladic value]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.StreamSort class</class-id> <category>api-new</category>

<body package="NGUBA-Application" selector="smeeNewWithPrototype:named:schema:">smeeNewWithPrototype: prototype named: aStringName schema: anInputSchema 
	&lt;constructByEitherWithArgs: #(prototype name schema ) comment: 'Instantiate a new operator, connect it to a schema.'&gt;
	
	^(self smeeNewWithPrototype: prototype)
		name: aStringName smeeToString;
		initializeForInputs: (Array with: anInputSchema);
		yourself</body>
</methods>


<methods>
<class-id>PROVISO.UBA.SAMPassThruSchema</class-id> <category>parsing</category>

<body package="PVAdaptor-Schema" selector="collectorNumberFor:">collectorNumberFor: inputDescriptor
	"&lt;Integer&gt; Answer the collector number for the given input descriptor (hopefully, we will actually be able to map any given SAM metric file to a single collector number)."

	"Update: it looks like we will have to crack open the files, so ultimately, this method will go away in favor of methods that do idmap lookups to determine the collector number for individual metric records."
	
	" We are now no longer using ID-Maps so, get the collector number from the dc.cfg "

	^self environment collectorNumber </body>
</methods>


<methods>
<class-id>PROVISO.MultiMetricRecordWriteStream</class-id> <category>accessing</category>

<body package="PV-Tuple Storage Engine" selector="addDescriptor:at:">addDescriptor: aPvDataFile at: aRecordType

	self descriptors at: aRecordType put: aPvDataFile</body>
</methods>


<methods>
<class-id>PROVISO.MultiMetricRecordWriteStream</class-id> <category>accessing</category>

<body package="PV-Tuple Storage Engine" selector="addDescriptor:">addDescriptor: aPvDataFile

	self addDescriptor: aPvDataFile at: aPvDataFile getBofRecordType</body>
</methods>


<methods>
<class-id>PROVISO.StreamLabelProcessor</class-id> <category>logging</category>

<body package="PV-CME-Core" selector="logPerfSummary">logPerfSummary
	
	| stream |
	stream := 
		String new writeStream
			nextPutAll: self currentHour printString;
			nextPutAll: '  Total: ';
			print: self stats totalSeconds;
			nextPutAll: '  Total work: ';
			print: self stats totalSecondsOfWork;
			nextPutAll: '  Pre: ';
			print: (self stats timingFor: #preHourlySeconds);
			nextPutAll: '  HourlyFileProcessing: ';
			print: (self stats timingFor: #hourlyProcessingFilesMilliseconds) // 1000;
			nextPutAll: '  Post: ';
			print: (self stats timingFor: #postHourlySeconds);

			nextPutAll: '  Raw In: ';
			print: self stats metricRecordsIn;
			nextPutAll: '  Raw Out: ';
			print: self stats metricRecordsOut;
			nextPutAll: '  Ra Out: ';
			print: self stats raRecordsOut;
			nextPutAll: '  Raw Out/Min: ';
			print: self stats metricRecordsOutPerMinute;
                  nextPutAll: '  Raw Out/Min Of Work ';
                  print: self stats adjustedStatistics;
			nextPutAll: '  Ra Out/Min: ';
			print: self stats raRecordsOutPerMinute;
			nextPutAll: '  TrapsGenerated: ';
			print: self stats trapEvents;
			nextPutAll: '  Compactions: ' , ObjectMemory currentMemoryPolicy compactionsString;
			nextPutAll: '  ReInventory Requests: ';
			print: self stats reInventoryRequests;
			nextPutAll: '  sucesses: ';
			print: self stats reInventorySuccesses;
			nextPutAll: '  failures: ';
			print: self stats reInventoryFailures;

			nextPutAll: '  BeginWait: ';
			print: (self stats timingFor: #beginWaitSeconds);
			nextPutAll: '  PreMetadataLoad: ';
			print: (self stats timingFor: #preHourlyLoadMetadataSeconds);
			nextPutAll: '  PreTreeBuild: ';
			print: (self stats timingFor: #preHourlyTreeBuildSeconds);
			nextPutAll: '  PreFlowControl: ';
			print: (self stats timingFor: #preHourlyFlowControlSeconds);

			nextPutAll: '  Hourly: ';
			print: (self stats timingFor: #hourlySeconds);
			nextPutAll: '  HourlyFlowControl: ';
			print: (self stats timingFor: #hourlyFlowControlSeconds);
			nextPutAll: '  TrapProcessingTime: ';
			print: (self stats timingFor: #hourlyTrapMilliseconds) // 1000;
			nextPutAll: '  HourlyWaitForData: ';
			print: self stats hourlyWaitForDataSeconds;

			nextPutAll: '  PostFlush: ';
			print: (self stats timingFor: #postHourlyFlushSeconds);
			nextPutAll: '  PostCleanup: ';
			print: (self stats timingFor: #postHourlyCleanupSeconds);
			nextPutAll: '  PostFlowControl: ';
			print: (self stats timingFor: #postHourlyFlowControlSeconds);
			nextPutAll: '  LoadBaselineState: ';
			print: (self stats timingFor: #loadBaselineState);
			nextPutAll: '  PreBaselineHistoryFromDB: ';
			print: (self stats timingFor: #preBaselineHistoryFromDB);
			nextPutAll: '  UpdateBaselineState: ';
			print: (self stats timingFor: #updateBaselineState);
			nextPutAll: '  PostBaselineHistoryFromDB: ';
			print: (self stats timingFor: #postBaselineHistoryFromDB);

			yourself.
	self system 
		logDebugOne: #PERF_SUMMARY
		messageId: nil
		text: stream contents</body>
</methods>

<methods>
<class-id>PROVISO.StreamLabelProcessor</class-id> <category>utility/debugging</category>

<body package="PV-CME-Core" selector="debug">debug
	"PROVISO.UBA.Environment new do: [self new debug]"

	| aChannelNumber cNum currentHourString dbEnvironment dbUsername dbPassword currentHourTimestamp cme numberOfTimesToResync seconds |

	aChannelNumber := 2. 
	cNum := 202.
	currentHourString := '2007.07.25-15.00.00'. 
	dbEnvironment := 'PRAGA'.
	dbUsername := 'PV_channel_01'. 
	dbPassword := 'pv'. 
	currentHourTimestamp := PvTimestamp readFrom: currentHourString readStream. 
	self currentApplication notNil ifTrue: [[self currentApplication stopImmediate] on: PvNeedToDieException do: [:ex | ]]. PvUnitTestApplication new 
		facilityName: 'CME.', aChannelNumber printString, '.', cNum printString; 
		start; 
		useTestCaseFileLogger. 
	self currentApplication logger logToTranscript: true. 
	ObjectMemory installPvMemoryPolicy. 
	cme := PvCmeEngine new. 
	cme dbSession disconnect; 
	setUsername: dbUsername password: dbPassword environment: dbEnvironment. 
	cme pvModel: self getPvModel. 
	cme pvModel initializeForCmePlanBased; 
	loadCollectorsByChannel. 
	self system runningApplication server: cme. 
	cme 
		currentHour: currentHourTimestamp; 
		configuration: ( 
			PvConfiguration new at: 'ROOT_DIRECTORY' put: 'DCTEST'; 
			at: 'CHANNEL' put: aChannelNumber printString; 
			at: 'FC_FSLL' put: '1000000'; 
			at: 'FC_QUOTA' put: '100000000'; 
			at: 'POLL_INTERVAL' put: '1' ; 
			at: 'COLLECTOR' put: cNum printString; 
			at: 'INPUT_DIRECTORIES' put: 'DCTEST/FTE.1.3/output'; 
			at: 'GA_ROLLUP_RELATIONS' put: 'qcf5620_local,qcf5620_endPoint1'; yourself); 
		channel: aChannelNumber; 
		postInitialize.
	cme dbSession 
		doSelect: true;
		doNonSelect: false.
	cme
		hookPreRun; 
		testMode: false. 

	numberOfTimesToResync := 3. 
	seconds := (PvTimestamp fromString: currentHourString) asSeconds. 
	1 to: numberOfTimesToResync do: 
		[:i | 
		cme streamLabelOperator
			startOfPeriod: seconds;
			doPreHourlyProcessing;
			inspect. 
		seconds := seconds + 3600].</body>
</methods>



</st-source>
