--
--  Netcool/OMNIbus 3.6 SQL definition file
--
-- Ident: $Id: NCOMS.sql 1.32 2003/05/01 09:45:17 nick Development $
--

create database master;
use database master;

create table names
(
	Name    	varchar(64),
	UID     	int,
	GID     	int,
	Passwd  	varchar(64),
	Type    	int,
	primary key ( Name ),
	permanent
);

create table profiles
(
	UID     	int,
	HasRestriction	int,
	Restrict1       varchar(255),
	Restrict2       varchar(255),
	Restrict3       varchar(255),
	Restrict4       varchar(255),
	AllowISQL       int,
	primary key ( UID ),
	permanent
);

create table permissions
(
	UID		int,
	AllowISQLWrite  int,
	primary key ( UID ),
	permanent
);


create table groups
(
	Name    varchar(64),
	GID     int,
	primary key ( Name ),
	permanent
);

create table members
(
	KeyField        varchar(64),
	UID             int,
	GID             int,
	primary key( KeyField ),
	permanent
);

--__DSD__create table national
--__DSD__(
--__DSD__	KeyField	incr,
--__DSD__	MasterServer	varchar(11),
--__DSD__	DualWrite	int,
--__DSD__	permanent
--__DSD__);

--
-- The following table controls the statistics option
-- Remove the comments to enable statistics gathering. Currently, this data
-- is gathered but not used.
--
-- You can comment out individual fields to stop that statistic being recorded
-- but the StatTtime must be present for the statistics gather to work
--
-- create table stats
-- (
        -- StatTime        time,
        -- NumClients      int,
        -- NumRealtime     int,
        -- NumProbes       int,
        -- NumGateways     int,
        -- NumMonitors     int,
        -- NumProxys       int,
        -- EventCount      int,
        -- JournalCount    int,
        -- DetailCount     int,
        -- primary key( StatTime ),
        -- permanent
-- );

create database auto;
use database auto;

create table triggers
(
	Name		varchar(64),
	Cond1		varchar(255),
	Cond2		varchar(255),
	Cond3		varchar(255),
	Cond4		varchar(255),
	AutoExec	varchar(64),
	DecExec		varchar(64),
	OwnerUID	int,
	Active		int,
	Level		int,
	EvalPeriod	int,
	Threshold	int,
	Hits		int,
	ProcessAllHits	int,
	Comment1	varchar(255),
	Comment2	varchar(255),
	Comment3	varchar(255),
	Comment4	varchar(255),
	Operator	int,		-- 0> 1>= 2< 3<= 4= 5!=
	TargetCount	int,
	primary key ( Name ),
	permanent
);

create table actions
(
	Name		varchar(64),
	HasData		int,
	Data1		varchar(255),	
	Data2		varchar(255),	
	Data3		varchar(255),	
	Data4		varchar(255),	
	HasExec		int,
	ExecPath	varchar(255),
	ExecArgs	varchar(255),
	ExecHost	varchar(64),
	EUID		int,
	HasPhone	int,
	PhoneArgs1	varchar(255),
	PhoneArgs2	varchar(255),
	PhoneArgs3	varchar(255),
	PhoneArgs4	varchar(255),
	Comment1	varchar(255),
	Comment2	varchar(255),
	Comment3	varchar(255),
	Comment4	varchar(255),
	UpdateJournal   int,            -- 0 = FALSE 
	primary key	( Name ),
	permanent
);


create database alerts;
use database alerts;

create table status
(
	Identifier      varchar(255),
	Serial          incr,
	Node            varchar(64),
	NodeAlias       varchar(64),
	Manager         varchar(64),
	Agent           varchar(64),
	AlertGroup 	varchar(64),
	AlertKey        varchar(255),
	Severity        int,
	Summary         varchar(255),
	StateChange	optime,
	FirstOccurrence time,
	LastOccurrence  ltime,
	InternalLast    timestamp,
	Poll            int,
	Type            int,	
	Tally           opcount,
	Class           int,
	Grade           int,
	Location        varchar(64),
	OwnerUID        int,
	OwnerGID        int,		-- Groups Option
	Acknowledged    int,
	Flash    	int,		-- Flash Option
	
	EventId		varchar(64),	-- Required by Precision 3.x
	ExpireTime	int,
	ProcessReq	int,		-- Required by Precision 3.x
	SuppressEscl	int,
	Customer	varchar(64),
	Service		varchar(64),
	PhysicalSlot	int,
	PhysicalPort	int,
	PhysicalCard	varchar(64),
	TaskList	int,
	
	NmosSerial	varchar(64),	-- Required by Precision 3.x
	NmosObjInst	int,		-- Required by Precision 3.x
	NmosCauseType	int,		-- Required by Precision 3.x
	
	LocalNodeAlias	varchar(64),	-- Required by Precision 3.x
	LocalPriObj	varchar(255),
	LocalSecObj	varchar(255),
	LocalRootObj	varchar(255),	-- Required by Precision 3.x
	RemoteNodeAlias	varchar(64),	-- Required by Precision 3.x
	RemotePriObj	varchar(255),
	RemoteSecObj	varchar(255),
	RemoteRootObj	varchar(255),
	
	X733EventType	int,
	X733ProbableCause	int,
	X733SpecificProb	varchar(64),
	X733CorrNotif	varchar(255),
	
	ServerName      varchar(64),
	ServerSerial    int,
--__DSD__	MasterSerial    int,		-- DSD Master serial
        provisoSubElementIndex  int,
--        provisoThresholdType    varchar(64),
        provisoThresholdType    int,
        provisoViolationTime            ltime,
        provisoSubElementGrpIndex       int,
	primary key ( Identifier ),
	permanent
);

create table objclass
(
	Tag	int,
	Name	varchar(64),
	Icon	varchar(255),
	Menu	varchar(64),
	primary key	( Tag ),
	permanent
);

create table objmenus
(
	Menu	       varchar(64),
	Columns	       int,
	primary key	( Menu ),
	permanent
);

create table objmenuitems
(
	KeyField       varchar(255),
	Menu	       varchar(64),
	Sequence       int,
	Title	       varchar(64),
	Command1       varchar(255),
	Command2       varchar(255),
	Command3       varchar(255),
	Command4       varchar(255),
	RedirectStdin  int,
	RedirectStdout int,
	RedirectStderr int,
	primary key  ( KeyField ),
	permanent
);

create table resolutions
(
	KeyField    	varchar(255),
	Tag         	int,
	Sequence    	int,
	Title       	varchar(64),
	Resolution1 	varchar(255),
	Resolution2 	varchar(255),
	Resolution3 	varchar(255),
	Resolution4 	varchar(255),
	primary key  ( KeyField ),
	permanent
);

create table journal
(
	KeyField   	varchar(255),
	Serial		int,
	UID		int,
	Chrono		time,
	Text1		varchar(255),
	Text2		varchar(255),
	Text3		varchar(255),
	Text4		varchar(255),
	Text5		varchar(255),
	Text6		varchar(255),
	Text7		varchar(255),
	Text8		varchar(255),
	Text9		varchar(255),
	Text10		varchar(255),
	Text11		varchar(255),
	Text12		varchar(255),
	Text13		varchar(255),
	Text14		varchar(255),
	Text15		varchar(255),
	Text16		varchar(255),
	primary key ( KeyField ),
	permanent
);

create table conversions
(
	KeyField        varchar(255),
	Colname		varchar(255),
	Value		int,
	Conversion	varchar(255),
	primary key  ( KeyField ),
	permanent
);

create table col_visuals
(
	Colname		varchar(255),
	Title		varchar(255),
	DefWidth	int,
	MaxWidth	int,
	TitleJustify    int,
	DataJustify     int,
	primary key ( Colname ),
	permanent
);


create table details
(
	KeyField   varchar(255),
	Identifier varchar(255),
	AttrVal    int,
	Sequence   int,
	Name       varchar(255),
	Detail     varchar(255),
	primary key  ( KeyField ),
	permanent
);

-- This table is required for the generic clear automation
create table generic_clear_problem_events 
(
	Identifier char(255),
	LastOccurrence time,
	AlertKey char(255),
	AlertGroup char(64),
	Manager char(64),
	Node char(64),
	Resolved int,
	primary key (Identifier) 
);

-- This table is required for the NT desktop
create table colors 
(
        Severity        int,
        AckedRed        int,
        AckedGreen      int,
        AckedBlue       int,
        UnackedRed      int,
        UnackedGreen    int,
        UnackedBlue     int,
        primary key( Severity ),
	permanent
);

-- The following database and table is required for the additional features
-- to support the Internet Service Monitors

create database service;
use database service;

create table status
(
	Name            varchar(255),      -- Service Name
	CurrentState    int,            -- Good, Marginal, Bad, Unknown
	StateChange     time,           -- Time of last service state change
	LastGoodAt      time,           -- Time service was last good
	LastBadAt       time,           -- Time service was last bad
	LastMarginalAt  time,           -- Time service was last marginal
	LastReportAt    time,           -- Time of last service status report
	primary key ( Name ),
	permanent
);

-- This database and table support the Java Event List and the Java JELD.
-- It is maintained via the JACE configuration tool.
create database jel;
use database jel;

create table jel_props
(
	KeyField        incr,
	ConfigName      varchar(127),
	PropSet         varchar(127),
	PropName        varchar(127),
	PropVal         varchar(255),
	primary key( KeyField ),
	permanent
);


-- This database and tables are required for the desktop dynamic tools.

create database tools;
use database tools;

create table actions
(
        ActionID        int,
        Name            varchar(64),
        Owner           int,
        Enabled         int,
        Description1    varchar(255), 
        Description2    varchar(255),
        Description3    varchar(255),
        Description4    varchar(255),
        HasInternal     int,
        InternalEffect1 varchar(255),
        InternalEffect2 varchar(255),
        InternalEffect3 varchar(255),
        InternalEffect4  varchar(255),
	InternalForEach	int,
        HasExternal      int,
        ExternalEffect1  varchar(255),
        ExternalEffect2  varchar(255),
        ExternalEffect3  varchar(255),
        ExternalEffect4  varchar(255),
	ExternalForEach	 int,
	RedirectOut	 int,
	RedirectErr	 int,
        Platform         varchar(255),
        JournalText1     varchar(255),
        JournalText2     varchar(255),
        JournalText3     varchar(255),
        JournalText4     varchar(255),
	JournalForEach	 int,
        HasForcedJournal int,
        primary key ( ActionID ),
	permanent
);

create table action_access
(
        ActionID        int,
        GID		int,
        ClassID         int,
        ActionAccessID  int,
        primary key ( ActionAccessID ),
	permanent
);

create table menus
(
        MenuID          int,
        Name            varchar(64),
        Owner           int,
        Enabled         int,
        primary key ( MenuID ),
	permanent
);


create table menu_items
(
        KeyField        varchar(32), -- menu_id:menu_item_id
        MenuID          int,
        MenuItemID      int,
        Title           varchar(64),
        Description     varchar(255),
        Enabled         int,
        InvokeType      int, -- What type of invocation: Action/Submenu
        InvokeID        int,
        Position        int,
        Accelerator     varchar(32),
        primary key ( KeyField ),
	permanent
);

create table menu_defs
(
	Name		varchar(64),
	DatabaseName	varchar(64),
	TableName	varchar(64),
	ShowField	varchar(64),
	AssignField	varchar(64),
	OrderbyField	varchar(64),
	WhereClause	varchar(255),
	Direction       int,
	primary key ( Name ),
	permanent       
);
 
create table prompt_defs
(
	Name		varchar(64),
	Prompt		varchar(64),
	Default		varchar(64),
	Value		varchar(255),
	Type            int,
	primary key ( Name ),
        permanent
);

--
-- Create a custom database. This is the database into which custom tables
-- should be added that require manipulation by probes.
--
create database custom;
